// DgCmdObj.cpp : Implementation of CDgCmdObj
#include "stdafx.h"
#include "DgCmd.h"
#include "DgCmdObj.h"
#include <atlconv.h>  // for ATL string conversion macros

/////////////////////////////////////////////////////////////////////////////
// CDgCmdObj

CDgCmdObj::CDgCmdObj()
{
	Files=NULL;
	Num=0;
}

CDgCmdObj::~CDgCmdObj()
{
	FreeFiles();
}

void CDgCmdObj::FreeFiles()
{
	UINT i;
	if (Files) {
		for (i=0;i<Num;i++) {
			free(Files[i]);
		}
		free(Files);
	}
}

HRESULT CDgCmdObj::Initialize (LPCITEMIDLIST pidlFolder,LPDATAOBJECT pDataObj,HKEY hProgID)
{
	HDROP hDrop;
	UINT i;
	FORMATETC fmt={CF_HDROP, NULL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL};
	STGMEDIUM stg = {TYMED_HGLOBAL};

	// ޵ ϸ 
    if (FAILED(pDataObj->GetData(&fmt, &stg))) {
        return E_INVALIDARG;
	}
    hDrop=(HDROP)GlobalLock(stg.hGlobal);
	if (hDrop==NULL) {
		return E_INVALIDARG;
	}

	FreeFiles();
	Num=DragQueryFile(hDrop,0xFFFFFFFF,NULL,0);
	Files=(TCHAR **)malloc(Num*sizeof(TCHAR *));
	for (i=0;i<Num;i++) {
		Files[i]=(TCHAR *)malloc(MAX_PATH);
		DragQueryFile(hDrop,i,Files[i],MAX_PATH);
	}

    GlobalUnlock(stg.hGlobal);
    ReleaseStgMedium (&stg);
    return NOERROR;
}

HRESULT CDgCmdObj::QueryContextMenu (HMENU hmenu, UINT  uMenuIndex, UINT  uidFirstCmd, 
	 UINT  uidLastCmd, UINT  uFlags )
{
	//  Ŭ ؼ ƹ ۵  ʴ´.
	if (uFlags & CMF_DEFAULTONLY) {
		return MAKE_HRESULT(SEVERITY_SUCCESS,FACILITY_NULL,0);
	}
	
	//  Ǿ ޴  ʴ´.
	//   ġ  ʰ  ϸ ϴ    ó ʿϴ.
	TCHAR InstPath[MAX_PATH];
	BOOL bExe=TRUE;
	SHRegReadString(SHCU,"Software\\Miyoungsoft\\Dangeun\\1.2\\Setting",
		"InstPath","",InstPath,MAX_PATH);
	if (lstrlen(InstPath) != 0) {
		HANDLE hFile;
		hFile=CreateFile(InstPath,0,0,NULL,OPEN_EXISTING,0,NULL);
		if (hFile == INVALID_HANDLE_VALUE) {
			bExe=FALSE;
		}
		CloseHandle(hFile);
	} else {
		bExe=FALSE;
	}

	if (bExe == FALSE) {
		return MAKE_HRESULT(SEVERITY_SUCCESS,FACILITY_NULL,0);
	}
	
	// ޴ 
	InsertMenu (hmenu,uMenuIndex,MF_BYPOSITION,uidFirstCmd,TEXT(" "));
	return MAKE_HRESULT(SEVERITY_SUCCESS,FACILITY_NULL,1 );
}

HRESULT CDgCmdObj::GetCommandString (UINT  idCmd,UINT  uFlags,UINT* pwReserved,
	LPSTR pszName,UINT  cchMax)
{
    USES_CONVERSION;
    LPCTSTR szHelp=_T(" ؽƮ    մϴ.");
	if (idCmd==0) {
		if (uFlags & GCS_HELPTEXT) {
            lstrcpynW((LPWSTR)pszName,T2CW(szHelp),cchMax);
		} else {
            lstrcpynA(pszName,T2CA(szHelp),cchMax);
		}
		return S_OK;
	}
    return E_INVALIDARG;
}

HRESULT CDgCmdObj::InvokeCommand(LPCMINVOKECOMMANDINFO pCmdInfo)
{
	UINT i;
	HWND hDg;
	TCHAR InstPath[MAX_PATH];
	TCHAR szCommand[MAX_PATH*2];
	STARTUPINFO si={0,};
	PROCESS_INFORMATION pi;
	ATOM hAtom;

	if (HIWORD(pCmdInfo->lpVerb))
		return E_INVALIDARG;
	
	switch (LOWORD(pCmdInfo->lpVerb )) {
	case 0:
		SHRegReadString(SHCU,"Software\\Miyoungsoft\\Dangeun\\1.2\\Setting",
			"InstPath","",InstPath,MAX_PATH);
		for (i=0;i<Num;i++) {
			// 丮  
			if (GetFileAttributes(Files[i]) & FILE_ATTRIBUTE_DIRECTORY) {
				continue;
			}
			hDg=FindWindow("Dangeun",NULL);
			//    Ų.
			if (hDg==NULL) {
				wsprintf(szCommand,"%s \"%s\"",InstPath,Files[i]);
				if (CreateProcess(NULL,szCommand,NULL,NULL,FALSE,0,NULL,NULL,&si,&pi)) {
					WaitForInputIdle(pi.hProcess,5000);
					CloseHandle(pi.hProcess);
					CloseHandle(pi.hThread);
				}
			// ̸   Ѵ.
			} else {
				hAtom=GlobalAddAtom(Files[i]);
				SendMessage(hDg,WM_USER+1,(WPARAM)hAtom,0);
				GlobalDeleteAtom(hAtom);
				SetForegroundWindow(hDg);
			}
		}
		return S_OK;
	default:
		return E_INVALIDARG;
	}
}
